#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var commander_1 = require("commander");
var update_notifier_1 = __importDefault(require("update-notifier"));
var fs_extra_1 = __importDefault(require("fs-extra"));
var open_1 = __importDefault(require("open"));
var reporter_1 = require("./lib/reporter");
var package_json_1 = __importDefault(require("../package.json"));
var chalk_1 = __importDefault(require("chalk"));
(0, update_notifier_1.default)({ pkg: package_json_1.default }).notify();
var stdin = '';
var program = new commander_1.Command();
program
    .version(package_json_1.default.version)
    .option('-o, --output [output]', 'output file')
    .option('-i, --input [input]', 'input file')
    .option('-O, --open', 'open report in default browser automatically')
    .option('-c, --theme [theme name]', 'template theme `dark` or `light` (defaults to `light`)')
    .option('-t, --template [handlebars file]', 'handlebars template file')
    .option('-f, --fatal-exit-code', 'exit with code 1 if vulnerabilities were found')
    .action(function (cmd) { return __awaiter(void 0, void 0, void 0, function () {
    var data, file, err_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 5, , 6]);
                data = void 0;
                if (!cmd.input) return [3 /*break*/, 2];
                return [4 /*yield*/, fs_extra_1.default.readFile(cmd.input)];
            case 1:
                file = _a.sent();
                data = file.toString('utf-8');
                return [3 /*break*/, 3];
            case 2:
                if (stdin) {
                    data = stdin;
                }
                _a.label = 3;
            case 3:
                if (!data) {
                    console.log(chalk_1.default.red('No input'));
                    return [2 /*return*/, process.exit(1)];
                }
                return [4 /*yield*/, genReport(data, cmd.output, cmd.template, cmd.theme, cmd.open, cmd.fatalExitCode)];
            case 4:
                _a.sent();
                return [3 /*break*/, 6];
            case 5:
                err_1 = _a.sent();
                console.log(chalk_1.default.red('Failed to parse NPM Audit JSON!'));
                return [2 /*return*/, process.exit(1)];
            case 6: return [2 /*return*/];
        }
    });
}); });
var genReport = function (data, outputFile, template, theme, openBrowser, fatalExitCode) {
    if (openBrowser === void 0) { openBrowser = false; }
    if (fatalExitCode === void 0) { fatalExitCode = false; }
    return __awaiter(void 0, void 0, void 0, function () {
        var res, err_2;
        var _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _c.trys.push([0, 4, , 5]);
                    if (!data) {
                        console.log(chalk_1.default.red('No JSON'));
                        return [2 /*return*/, process.exit(1)];
                    }
                    return [4 /*yield*/, (0, reporter_1.generateReport)({
                            auditJson: data,
                            templateFile: template,
                            outputFile: outputFile,
                            theme: theme
                        })];
                case 1:
                    res = _c.sent();
                    if (fatalExitCode && ((_b = (_a = res === null || res === void 0 ? void 0 : res.report) === null || _a === void 0 ? void 0 : _a.overview) === null || _b === void 0 ? void 0 : _b.totalVulnerabilities) > 0) {
                        process.exitCode = 1;
                    }
                    console.log("Vulnerability snapshot saved at " + res.outputFile);
                    if (!openBrowser) return [3 /*break*/, 3];
                    console.log('Opening report in default browser...');
                    return [4 /*yield*/, (0, open_1.default)(res.outputFile)];
                case 2:
                    _c.sent();
                    _c.label = 3;
                case 3: return [3 /*break*/, 5];
                case 4:
                    err_2 = _c.sent();
                    console.log(chalk_1.default.red(err_2));
                    process.exit(1);
                    return [3 /*break*/, 5];
                case 5: return [2 /*return*/];
            }
        });
    });
};
if (process.stdin.isTTY) {
    program.parse(process.argv);
}
else {
    process.stdin.on('readable', function () {
        var chunk = this.read();
        if (chunk !== null) {
            stdin += chunk;
        }
    });
    process.stdin.on('end', function () {
        program.parse(process.argv);
    });
}
