"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NpmAuditReportVersion1 = void 0;
var types_1 = require("../lib/types");
var NpmAuditReportVersion1 = /** @class */ (function () {
    function NpmAuditReportVersion1() {
        this.type = 'npm-v1';
    }
    NpmAuditReportVersion1.prototype.transformReport = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var json, totalVulnerabilities, vulnerabilityCounts, vul, count, report, modules, id, vulnerability, moduleName, advisories, highestSeverity, severity, _i, advisories_1, adv, vulnerableModule;
            return __generator(this, function (_a) {
                json = JSON.parse(data);
                totalVulnerabilities = 0;
                vulnerabilityCounts = json.metadata.vulnerabilities || [];
                for (vul in vulnerabilityCounts) {
                    count = vulnerabilityCounts[vul];
                    totalVulnerabilities += count;
                }
                report = {
                    createdAt: new Date(),
                    overview: {
                        info: json.metadata.vulnerabilities.info,
                        low: json.metadata.vulnerabilities.low,
                        moderate: json.metadata.vulnerabilities.moderate,
                        high: json.metadata.vulnerabilities.high,
                        critical: json.metadata.vulnerabilities.critical,
                        totalVulnerabilities: totalVulnerabilities,
                        totalDependencies: json.metadata.totalDependencies
                    },
                    vulnerabilities: []
                };
                modules = {};
                for (id in json.advisories) {
                    vulnerability = json.advisories[id];
                    if (!modules[vulnerability.module_name]) {
                        modules[vulnerability.module_name] = [];
                    }
                    modules[vulnerability.module_name].push(vulnerability);
                }
                for (moduleName in modules) {
                    advisories = modules[moduleName];
                    highestSeverity = 5;
                    severity = 'info';
                    for (_i = 0, advisories_1 = advisories; _i < advisories_1.length; _i++) {
                        adv = advisories_1[_i];
                        if (types_1.severityMap[adv.severity].number < highestSeverity) {
                            highestSeverity = types_1.severityMap[adv.severity].number;
                            severity = adv.severity;
                        }
                    }
                    vulnerableModule = {
                        name: moduleName,
                        severity: severity,
                        via: []
                    };
                    vulnerableModule.via = advisories.map(function (adv) {
                        return {
                            source: 1,
                            name: adv.module_name,
                            dependency: adv.module_name,
                            title: adv.title,
                            url: adv.url,
                            severity: adv.severity,
                            range: adv.vulnerable_versions
                        };
                    });
                    report.vulnerabilities.push(vulnerableModule);
                }
                return [2 /*return*/, report];
            });
        });
    };
    NpmAuditReportVersion1.prototype.isType = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var json;
            return __generator(this, function (_a) {
                try {
                    json = JSON.parse(data);
                    return [2 /*return*/, !!(json === null || json === void 0 ? void 0 : json.actions)];
                }
                catch (err) {
                    return [2 /*return*/, false];
                }
                return [2 /*return*/];
            });
        });
    };
    return NpmAuditReportVersion1;
}());
exports.NpmAuditReportVersion1 = NpmAuditReportVersion1;
